(function ($) {
    // initialize scrolltrigger and scrollto
    gsap.registerPlugin(ScrollTrigger, ScrollToPlugin, ScrollSmoother);

    if (ScrollTrigger.isTouch !== 1) {
        // create the smooth scroller FIRST!
        let smoother = ScrollSmoother.create({
            wrapper: 'main',
            content: '.main-container',
            smooth: 3,
            effects: true,
        });
    }

    // global

    window.onbeforeunload = function () {
        window.scrollTo(0, 0);
    };

    var scrollpos = window.scrollY
    var header = document.querySelector("header")
    var main = document.querySelector("main")
    var header_height = header.offsetHeight
    
    var add_class_on_scroll = () => header.classList.add("fixed")
    var remove_class_on_scroll = () => header.classList.remove("fixed")
    var add_class_on_scroll2 = () => main.classList.add("fixed")
    var remove_class_on_scroll2 = () => main.classList.remove("fixed")
    
    // if (scrollpos > 900) { 
    //     add_class_on_scroll();
    //     add_class_on_scroll2();
    // }
    
    window.addEventListener('scroll', function() { 
        scrollpos = window.scrollY;
    
        if (scrollpos > 500) { 
            add_class_on_scroll()
            add_class_on_scroll2()
        }
        else { 
            remove_class_on_scroll()
            remove_class_on_scroll2()
        }
    });

    var navHam = document.querySelector('.nav-ham');
    if(navHam) {
        navHam.addEventListener('click', function() {
            document.querySelector('header').classList.toggle('open');
            document.querySelector('body').classList.toggle('overflow');
            document.querySelector('.nav-ham .btns').classList.toggle('open');
            document.querySelector('.nav-ham .btns').classList.toggle('not-open');
        });
    }

    // homepage animations

    // start of script section 1
    const scrollingImage = document.getElementById('scrollingImage');
    const themacticIcon = document.getElementById('section2');

    if(scrollingImage) {
        // Animation and class addition when scrolling to section 2
        gsap.to(scrollingImage, 
            {
            scrollTrigger: {
                trigger: "#section2",
                start: "top center",
                end: "top center",
                scrub: true,
                onEnter: () => {
                    scrollingImage.classList.add('down');
                    themacticIcon.classList.add('down');
                }, // Add class when reaching section 2
            },
            x: "-50vw", // Move to the center-left
            y: "50%", // Keep it vertically centered
        });
        
        // Reset position and remove class when scrolling back to section 1
        gsap.to(scrollingImage, {
            scrollTrigger: {
                trigger: "#section1",
                start: "top center",
                end: "bottom center", // Ensures the reset happens when scrolling back
                scrub: true,
                onLeaveBack: () => {
                    gsap.to(scrollingImage, { x: "0", y: "0" }); // Reset position
                    scrollingImage.classList.remove('down'); // Remove class when scrolling back
                    themacticIcon.classList.remove('down'); // Remove class when scrolling back
                }
            },
        });
    }

    // const addClass = () => scrollingImage.classList.add('down');

    // const removeClass = () => scrollingImage.classList.remove('down');

    // gsap.fromTo(scrollingImage, 
    //     { 
    //         y: -50,
    //         xPercent: -50
    //     }, {
    //         y: -50,
    //         xPercent: -50,
    //         scrollTrigger: {
    //             trigger: "#section2",
    //             start: "top center",
    //             end: "top center",
    //             scrub: true,
    //             onEnter: () => {
    //                 gsap.to(scrollingImage, { y: -50, xPercent: -95, duration: 0 });
    //                 addClass(); // Add class when entering the trigger
    //             },
    //             onLeaveBack: () => {
    //                 gsap.to(scrollingImage, { y: -50, xPercent: -50, duration: 0 });
    //                 removeClass(); // Remove class when leaving back
    //             },
    //             onLeave: () => {
    //                 gsap.to(scrollingImage, { y: -50, xPercent: -95, duration: 0 });
    //                 addClass(); // Add class when leaving the trigger
    //             },
    //             onEnterBack: () => {
    //                 gsap.to(scrollingImage, { y: -50, xPercent: -95, duration: 0 });
    //                 addClass(); // Add class when re-entering the trigger
    //             },
    //         }
    //     }
    // );

    
    let tl2 = gsap.timeline();
    
    tl2.from(".left-hero-section", {
        x: "-50vw",
        opacity: 0,
        duration: 1
    })
    .from(".right-hero-section", {
        x: "50vw",
        opacity: 0,
        duration: 1
    }, "-=1")
    .from(".center-hero-section .photo", {
        scale: 0,
        opacity: 0,
        duration: 1.5
    }, "-=1");
    

    // slider testimonials
    var participantsSlider = new Swiper('.swiper-container.participants-slider', {
        spaceBetween: 50,
        slidesPerView: 5,
        autoplay: {
            delay: 0,
            disableOnInteraction:false,
        },
        loop: true,
        speed: 3000,
        breakpoints:{
            0:{ 
                slidesPerView: 2,
                spaceBetween: 50,
            },
            768: {
                slidesPerView: 3,
                spaceBetween: 50,
            },
            1024: {
                slidesPerView: 4,
                spaceBetween: 50,
            },
            1279: {
                slidesPerView: 5,
                spaceBetween: 40,
            },
            1536: {
                spaceBetween: 50,
            }
        }
    });

    // let section1Height = document.querySelector("#section1").offsetHeight;

    // gsap.utils.toArray("section").forEach((section, index) => {
    //     ScrollTrigger.create({
    //         trigger: section,
    //         start: "top top",
    //         end: "bottom top",
    //         onEnter: () => {
    //             if (index < document.querySelectorAll("section").length - 1) {
    //                 gsap.to(window, {
    //                 scrollTo: { y: "#section" + (index + 2), autoKill: false },
    //                 duration: 0,
    //                 ease: "power3.inOut"
    //                 });
    //             }
    //         },
    //         onLeaveBack: () => {
    //             if (index > 0) {
    //                 gsap.to(window, {
    //                 scrollTo: { y: "#section" + index, autoKill: false },
    //                 duration: 0,
    //                 ease: "power3.inOut"
    //                 });
    //             }
    //         }
    //     });
    // });

    
    //start of scripts section 2
    const slides = document.querySelectorAll('.thematics-slide');
    if(slides) {
        slides.forEach((slide, index) => {
            slide.style.top = `${index * 20}px`;
        });

        // slides.forEach((slide, index) => {
        //     slide.style.top = `${index * 30}px`;
        // });

        // const updatePositions = () => {
        //     slides.forEach((slide, index) => {
        //         const basePosition = index * 100;
        //         const currentTop = parseInt(slide.style.top, 10);
        //         const adjustment = slide.classList.contains('active') ? (currentTop > 0 ? -50 : 0) : 0;
        //         slide.style.top = `${basePosition + adjustment}px`;
        //     });
        // };

        // updatePositions();

        // const observer = new MutationObserver(updatePositions);
        // slides.forEach(slide => {
        //     observer.observe(slide, {
        //         attributes: true,
        //         attributeFilter: ['class']
        //     });
        // });
    }

    const targetElement = document.querySelector('.center-hero-section');
    let horizontalSlide = gsap.utils.toArray(".thematics-slide");

    function isLargeScreen() {
        return window.matchMedia("(min-width: 1023px)").matches;
    }

    if (isLargeScreen() && horizontalSlide.length) {
        gsap.to(horizontalSlide, {
            xPercent: -100 * horizontalSlide.length,
            ease: "none",
            scrollTrigger: {
                trigger: ".thematics-slider",
                start: "center center",
                pin: ".top-pin-bloc",
                pinSpacing: true,
                scrub: 1,
                end: "+=2500",
                onUpdate: self => updateActiveSlides(self)
            }
        });

        function updateActiveSlides(scrollTrigger) {
            // Ensure scrollTrigger is valid
            if (!scrollTrigger || typeof scrollTrigger.progress === 'undefined') {
                console.error('Invalid scrollTrigger object');
                return;
            }
            
            // Remove 'active' class from all slides
            horizontalSlide.forEach(slide => slide.classList.remove('active'));

            // Determine the current slide index
            let currentSlideIndex = Math.round(scrollTrigger.progress * (horizontalSlide.length - 1));

            // Add 'active' class to the slides up to the current index
            horizontalSlide.forEach((slide, index) => {
                if (index <= currentSlideIndex) {
                    slide.classList.add('active');
                }
            });

            // Update targetElement based on active slide
            if (horizontalSlide[1] && horizontalSlide[1].classList.contains('active')) {
                targetElement.classList.add('opac');
            } else {
                targetElement.classList.remove('opac');
            }
        }
    }


    // end of scripts section 2


    // start of scripts section 3
    var line = $('.inner-creative-section .text');

    var tl = new TimelineLite({
        onComplete: function(){
            tl.restart();
        }
    });
    
    TweenLite.defaultEase = Circ.easeInOut;

    var time = 0.75;
    var y = 50;

    tl.add (
        TweenMax.staggerFromTo
        (line, time, {
            delay: .3,
            opacity: 0,
            y: y,
        },
        {	
            delay: .3,
            opacity: 1,
            y: 0,
        }, 1.5 ))
        .add ( TweenMax.staggerTo (
            line, time,
            {
                delay: .3,
                opacity: 0,
                y: -y,
            },
        1.5 ), 1)

    // end of scripts section 3


    // start of scripts section 4
    const homenewsSection = document.querySelector('.inner-newsBloc-section');
    if (homenewsSection) {
        ScrollTrigger.create({
            trigger: '.news-section',
            pin: '.inner-newsTitle-section',
            start: 'top 20%',
            end: () => '+=' + homenewsSection.offsetHeight,
            scrub: true,
        });
    }

    // end of scripts section 4

    // end homepage animations


    // news details animation

    let tl3 = gsap.timeline();
    
    tl3.from(".left-bannerInner", {
        x: "-50vw",
        opacity: 0,
        duration: 1
    })
    .from(".right-bannerInner", {
        x: "50vw",
        opacity: 0,
        duration: 1
    }, "-=1");

    if ($('.news-details-section').length > 0) {
        gsap.utils.toArray('.news-details-section').forEach((newsDeAnimation, i) => {
            let newsDeAnim = gsap.timeline({
                scrollTrigger: {
                    trigger: newsDeAnimation,
                    start: "top center",
                }
            });
    
            newsDeAnim.from('.left-news-details', 1, {
                opacity: 0,
                y: 50,
                scale: .95,
            }).from('.center-news-details', 1, {
                opacity: 0,
                y: 50,
                scale: .95,
            }).from(".right-news-details", 1, {
                y: 50,
                opacity: 0,
                scale: .95,
            })
        });
    }


    // end news details animation


    // themes details animation

    if ($('.themes-ex-section').length > 0) {
        gsap.utils.toArray('.themes-ex-section').forEach((themesExAnimation, i) => {
            let themesExAnim = gsap.timeline({
                scrollTrigger: {
                    trigger: themesExAnimation,
                    start: "top center",
                }
            });
    
            themesExAnim.from('.inner-themes-ex .title-bloc .tit', 1, {
                opacity: 0,
                y: 50,
                scale: .95,
            }).from('.thematics-slides', 1, {
                opacity: 0,
                y: 50,
                stagger: .25
            }).from(".thematics-ex-text .title", 1, {
                x: "-50vw",
                opacity: 0,
            })
            .from(".thematics-ex-text .desc", 1, {
                x: "50vw",
                opacity: 0,
            });
        });
    }

    if ($('.news-section').length > 0) {
        gsap.utils.toArray('.news-section').forEach((newsSecAnimation, i) => {
            let newsSecAnim = gsap.timeline({
                scrollTrigger: {
                    trigger: newsSecAnimation,
                    start: "top center",
                }
            });
    
            newsSecAnim.from('.news-section .title-bloc .pre-ihb', 1, {
                opacity: 0,
                y: 50,
                scale: .95,
            }).from('.news-section .title-bloc .title-ihb', 1, {
                opacity: 0,
                y: 70,
                scale: .95,
            }).from('.inner-newsBloc-section', 1, {
                opacity: 0,
                scale: .95
            })
        });
    }

    if ($('footer').length > 0) {
        gsap.utils.toArray('footer').forEach((footerAnimation, i) => {
            let footerAnim = gsap.timeline({
                scrollTrigger: {
                    trigger: footerAnimation,
                    start: "top center"
                }
            });
    
            footerAnim.from('.inner-footer', 1, {
                opacity: 0,
                y: 50,
                scale: .8,
            })
        });
    }


    // initialize jquery
    $(document).ready(function() {

        var timeout;
        $('.move-parallax-section').mousemove(function(e){
            if(timeout) clearTimeout(timeout);
            setTimeout(callParallax.bind(null, e), 200);
        });
        
        function callParallax(e){
            parallaxIt(e, document.querySelectorAll('.image1'), -60);
            parallaxIt(e, document.querySelectorAll('.image2'), -30);
            parallaxIt(e, document.querySelectorAll('.image3'), 30);
            parallaxIt(e, document.querySelectorAll('.image4'), 20);
        }
        
        function parallaxIt(e, target, movement){
            var $this = $('.move-parallax-section');
            var relX = e.pageX - $this.offset().left;
            var relY = e.pageY - $this.offset().top;
          
            TweenMax.to(target, 1, {
                x: (relX - $this.width()/2) / $this.width() * movement,
                y: (relY - $this.height()/2) / $this.height() * movement,
                ease: Power2.easeOut
            })
        }


    });

})(jQuery);

document.addEventListener('DOMContentLoaded', function() {
    document.querySelector("div[name='webChat'] button i").innerHTML = "<img src='~/chatbot.png' width='40' />";
});